(* This code uses real ANSI instead of WWIV ANSI.  There are more
   straightforward ways of mapping colors to numbers, but this was
   done in such a way as to use Borland's standard color mappings. *)

CONST
  black    = 0;  blue         = 1;  green      = 2;  cyan      = 3;
  red      = 4;  magenta      = 5;  brown      = 6;  lightgray = 7;
  darkgray = 8;  lightblue    = 9;  lightgreen = 10; lightcyan = 11;
  lightred = 12; lightmagenta = 13; yellow     = 14; white     = 15;
  blink    = 16;

  ANSI : packed array [0..15] of char = '0426153704261537';

  esc = chr(27);

procedure foreground(fgnd:integer);
begin
  if okANSI then
    if (fgnd>blink)
      then if (fgnd>lightgray+blink)
        then prompt(esc+'[1m'+esc+'[5m'+esc+'[3'+ANSI[fgnd-blink]+'m')
        else prompt(esc+'[0m'+esc+'[5m'+esc+'[3'+ANSI[fgnd-blink]+'m')
      else if (fgnd>lightgray)
        then prompt(esc+'[1m'+esc+'[3'+ANSI[fgnd]+'m')
        else prompt(esc+'[0m'+esc+'[3'+ANSI[fgnd]+'m');
end;

procedure background(bgnd:integer);
begin
  if okANSI then
    prompt(esc+'[4'+ANSI[bgnd]+'m');
end;

procedure endANSI;
begin
  if okANSI then
    prompt(esc+'[0m');
end;

procedure Ansic(c : integer);
begin
  case c of
    1:foreground(lightcyan);
    2:foreground(yellow);
    3:foreground(magenta);
    4:begin
        foreground(white);
        background(blue);
      end;
    5:foreground(green);
    6:foreground(lightred+blink);
    else endANSI;
  end;
end;
